#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'View' => 'View',

	   );

my $self = 'viewldap.pl';

use DBI;
use CGI;
use Net::LDAP;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../etc/ldap.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $ldap = Net::LDAP->new( $servername ) or die "$@\n";

# $mesg = $ldap->bind ;    # an anonymous bind
# bind to a directory with dn and password
my $mesg = $ldap->bind( $adminuser, password => $adminpassword );


$mesg = $ldap->search( # perform a search
		       base   => $basedn,
		       filter => "(& (uid=*) )"
		       );


my $q = CGI->new;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

# Write HTML Header
print "$doctype\n<html><head><title>". $lex{View}. " LDAP</title>\n";
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">\n";
print "<style type=\"text/css\"> .cn { text-align:center;} .la {text-align:left;}</style>\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
#print "<a href=\"$exppage\">". $lex{Export}. "</a> ]\n";
print "<h1>". $lex{View}. " LDAP</h1>\n";

print "<pre>\n";
 
$mesg->code && die $mesg->error;
foreach $entry ($mesg->entries) { $entry->dump; }
$mesg = $ldap->unbind;   # take down session

print "</pre></body></html>\n";
