#!/usr/bin/perl
#  Copyright 2001-2012 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Youngest in Family' => 'Youngest in Family',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Sort by' => 'Sort by',
	   'Select' => 'Select',
	   'Error' => 'Error',
	   'Blank=All' => 'Blank=All',

	   );

my $self = 'rptyoungest.pl';

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


my $sortorder = "lastname, firstname";
if ( $arr{sortorder} eq 'homeroom' ) {
    $sortorder = 'homeroom, lastname, firstname';
} elsif ( $arr{sortorder} eq 'grade' ) {
    $sortorder = 'grade, lastname, firstname';
}


my $select;
if ( $arr{group} or $arr{homeroom} ) {
    if ( $arr{select} eq 'grade' ) { # Find this grade;
	my $grp = $dbh->quote( $arr{group} );
	$select = "and grade = $grp";
    } elsif ( $arr{select} eq 'homeroom' ) {
	my $grp = $dbh->quote( $arr{group} );
	$select = "and homeroom = $grp";
    } else { # must be old homeroom...
	my $homeroom = $dbh->quote($arr{homeroom});
	$select = "and homeroom = $homeroom";
    }
}


# Print Page Header
print "$doctype\n<html><head><title>$lex{'Youngest in Family'}</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "<div style=\"display:inline;\">";
print "[ <a href=\"$homepage\">$lex{Main}</a> ]\n";


# Start of Form
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"submit\" value=\"$lex{'Sort by'}\">\n";
print "<select name=\"sortorder\">\n";

if ( $arr{sortorder} ) { print "<option>$arr{sortorder}</option>\n"; }

print "<option value=\"name\">$lex{Name}</option>\n";
print "<option value=\"homeroom\">$lex{Homeroom}</option>\n";
print "<option value=\"grade\">$lex{Grade}</option>\n";
print "</select>\n";

print "<input type=\"submit\" value=\"$lex{Select}\">\n";
print "<select name=\"select\">\n";
print "<option value=\"grade\">$lex{Grade}</option>\n";
print "<option value=\"homeroom\">$lex{Homeroom}</option>\n";
print "</select>\n";
print "<input type=\"text\" name=\"group\" size=\"6\" value=\"$arr{group}\">\n";
print "</form>$lex{'Blank=All'}</div>\n";


print "<h1>$lex{'Youngest in Family'}</h1>\n";
print "<h3>$schoolname<br>$currdate</h3>\n";


if ( not $arr{page} ) { # stop if just first entry
    print "</body></html>\n";
    exit;
}


# Select Data
my $sth = $dbh->prepare("select lastname, firstname, initial, homeroom, grade, youngest, 
  relation1, name1, hphone1, wphone1, relation2, name2, hphone2, wphone2 from student 
  where ( youngest is not null and youngest <> '' ) $select order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }



my $curroom = -1;
my $first = 1;

while ( my ($lastname, $firstname, $middlename, $homeroom, $grade, $youngest, 
  $relation1, $parent1, $hphone1, $wphone1, $relation2, $parent2, $hphone2, $wphone2) = $sth->fetchrow) {

    $oldroom = $curroom;
    $curroom = $hroom;
  
    if ($curroom ne $oldroom) {
	if (not $first) { print "</table><p></p>\n"; } else { $first = 0; }
	print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
	print "<tr><th>$lex{Name}</th><th>$lex{'Parent 1'}</th><th>$lex{'Parent 2'}</th></tr>\n";
    } 

    print "<tr><td><b>$lastname</b>, $firstname $middlename<br><b>Gr:</b> $grade<br><b>Hr:</b> $homeroom</td>\n";
    print "<td><b>Rel:</b> $relation1<br>$parent1<br>H:$hphone1<br>W:$wphone1</td>\n";
    print "<td><b>Rel:</b> $relation2<br>$parent2<br>H:$hphone2<br>W:$wphone2</td></tr>\n";
  
}

print "</table></body></html>\n";
