#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Error' => 'Error',
	   'School' => 'School',
	   'Objectives' => 'Objectives',
	   'Term' => 'Term',
	   'Comments' => 'Comments',
	   'Please Log In' => 'Please Log In',
	   'View' => 'View',
	   'Evaluations' => 'Evaluations',
	   'Main' => 'Main',

	   );

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"$lex{'Please Log In'}\">\n";
    print "</form></body></html>\n";
    exit;

}

my $userid = $session->param('userid');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Heading
my $title = "$lex{View} $lex{Evaluations}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$tchpage\">$lex{Main}</a> ] $firstname $lastname\n";


# Find students in evalmst; push into array.
$sth = $dbh->prepare("select distinct e.studnum 
  from iep_evalmst e, iep_student s
  where s.studnum = e.studnum $select
  order by s.lastname, s.firstname");
$sth->execute;
my @students;
if ( $DBI::errstr ) {print $DBI::errstr; die $DBI::errstr; }
while ( my $sn = $sth->fetchrow ) {
    push @students, $sn;
} 
# Student numbers now in @students sorted by name



foreach my $studnum ( @students ) { # Once for each student.

    # Find the student name
    $sth = $dbh->prepare("select lastname, firstname from iep_student where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow; 
    my $studname = "$firstname $lastname ($studnum)";

    # Find their subjects.
    $sth = $dbh->prepare("select * from iep_evalmst where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    # Now table for this student
    print "<h2>$studname</h2>\n";
    print "<table>\n";


    # Loop; once for each subject.
    for ( my $i=1; $i <= $rows; ++$i ) {

	my @evalmst = $sth->fetchrow;
	my $subnum = $evalmst[2];

	#lookup subject name
	my $sth1 = $dbh->prepare("select category from iep_objectives where catnum = ?");
	$sth1->execute( $subnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth1->fetchrow; 
	my $subname = "$category ($subnum)";

	   
	# Now find all term records for this subject for this student.
	my $sth2 = $dbh->prepare("select * from iep_eval 
         where studnum = ? and subnum = ? order by term");
	$sth2->execute( $studnum, $subnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $termrows = $sth2->rows;

	# Loop through all terms, pushing evaluations into array.   
	for ( my $j=1; $j<=$termrows; $j++ ) {
	    @termeval = $sth2->fetchrow;
	    $master[ $j ] = [ @termeval ];
	}

	print "<p><b>$subname</b></p>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Objectives}. "</th>\n";

	for (1..$termrows){
	    print "<th>Term $_</th>";
	}
	print "</tr>\n"; # End of Table Header

	# Now print the table
	for ( my $j=3; $j<=34;$j++ ){
	    if ( $evalmst[ $j ] ) {
		print "<tr><td>$evalmst[$j]</td>";
		for ( my $k=1;$k<=$termrows;$k++ ) {
		    print "<td>$master[$k]->[$j]</td>";
		}
		print "</tr>\n";
	    }
	}

	# print comments at end of table.
	my $colspan = $termrows + 1;
	print "<tr><td colspan=\"$colspan\">\n";
	for ( my $k=1;$k<=$termrows; $k++ ) {
	    print "<b>". $lex{Term}. " $k ". $lex{Comments}. ":</b> $master[$k]->[36]<br>\n";
	    #print"T:1 $master[1][36]<br>T:2 $master[2][36]<br>";
	}
	print "</td></tr></table>\n";

    } # End of Subject "For" Loop
    
} # End of Student Loop

print "</body></html>\n";
