#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.
#  Outline: View Evaluation Outline for Current School


my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'View All Eval Masters' => 'View All Eval Masters',
	   'Click on <i>Subject</i> to edit Objectives Text' => 
	     'Click on <i>Subject</i> to edit Objectives Text',
	   'Subject' => 'Subject',
	   'Objectives' => 'Objectives',
	   'Strategies' => 'Strategies',
	   'Responsible' => 'Responsible',
	   'Long Term Objective' => 'Long Term Objective',
	   'Impact Area' => 'Impact Area',
	   'Please Log In' => 'Please Log In',
	   'View' => 'View',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',


	   );

my $self = 'iepobjectiveview.pl';

use DBI;
use CGI;
use CGI::Session;


my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"$lex{'Please Log In'}\">\n";
    print "</form></body></html>\n";
    exit;

}

my $userid = $session->param('userid');


# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Homerooms and Access for this teacher.
my (%homerooms, %access );
if ( $arr{page} == 2 ) { # get access checking ready

    # Get homeroom and check access credentials.
    my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'homeroom' and userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $homeroom = $sth->fetchrow ) {
	$homerooms{$homeroom} = 1;
    }

    # Get Access credentials
    my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'access' and userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $ac = $sth->fetchrow ) {
	$access{$ac} = 1;
    }
}


# Print Page Head
my $title = qq{$lex{View} $lex{Objectives}};

print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$tchpage\">$lex{Main}</a> ] $firstname $lastname\n";

print qq{<a name="top"></a><h1>$title</h1>\n};


# Find the Objectives and the Students
my $sth = $dbh->prepare("select s.studnum, e.subnum from iep_evalmst as e, iep_student as s
  where e.studnum = s.studnum  order by s.lastname, s.firstname, e.subnum");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


my $currstud = '-1'; # unlikely value
my $prevstud;

my $sth1 = $dbh->prepare("select category from iep_objectives where catnum = ?");
my $sth2 = $dbh->prepare("select * from iep_evalmst where subnum = ? and studnum = ?");
my $sth3 = $dbh->prepare("select lastname, firstname, grade from iep_student where studnum = ?");
my $first = 1;

while ( my ($studnum, $catnum) = $sth->fetchrow ) {

   # lookup subject name (category);
   $sth1->execute( $catnum );
   if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
   my $category = $sth1->fetchrow; 

   # pull in eval master record
   $sth2->execute( $catnum, $studnum );
   if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
   my $ref = $sth2->fetchrow_hashref; 
   my %em = %$ref; # eval master.

   # print objectives
#   foreach my $key ( sort keys %em ) { print "K:$key V:$em{$key}<br>\n"; }

   $prevstud = $currstud;
   $currstud = $studnum;     

   if ( $oldstud ne $currstud ) {  

       # new student: pull in name, finish old table, print new name.
       # Lookup Student Name
       $sth3->execute( $currstud );
       if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
       my ($lastname, $firstname, $grade) = $sth3->fetchrow;
   
       if (not $first ) { 
	   print qq{</table>[ <a href="#top">Top</a> ]\n\n}; 
       } else { $first = 0; } 

       print "<h3>$firstname $lastname ($currstud)  Grade $grade</h3>\n";
       print "<p>$lex{'Click on <i>Subject</i> to edit Objectives Text'}</p>\n";
       print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
       print "<tr><th>$lex{Subject}</th><th>$lex{Objectives}</th></tr>\n";      
   
   }
   
   print "<tr><td><a href=\"iepobjectiveed.pl?studnum=$studnum&catnum=$catnum\">$category</a></td>\n";
   print "<td><ul>\n";
   for my $i (1..32) {
       my $key = 'obj'. $i;
       if ( $em{$key} ){ print "<li>$em{$key}</li>\n"; }
   }

   print "</ul><p><b>$lex{Strategies}:</b> $em{strategy}<br>\n";
   print "<b>$lex{Responsible}:</b> $em{responsible}<br>\n";
   print "<b>$lex{'Long Term Objective'}:</b> $em{longtermobjective}<br>\n";


} # End of objective loop

if ( $first ) {
    print qq{<h3>No Records Found</h3>\n};
} else {
    print qq{</table>[ <a href=\"#top\">Top</a> ]\n};
}

print qq{</body></html>\n};
