#!/usr/bin/perl

#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Edit' => 'Edit',
	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Birthdate' => 'Birthdate',
	   'Student Number' => 'Student Number',
	   'Provincial Number' => 'Provincial Number',
	   'Designation Date' => 'Designation Date',
	   'DDPF Level' => 'DDPF Level',
	   'Designation' => 'Designation',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'M' => 'M',
	   'F' => 'F',
	   'Medical Conditions' => 'Medical Conditions',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'School/Home History' => 'School/Home History',
	   'Save Student Record' => 'Save Student Record',
	   'More Students' => 'More Students',
	   'Contact' => 'Contact',
	   'Summary?' => 'Summary?',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'The record is updated' => 'The record is updated',
	   'Please Log In' => 'Please Log In',
	   'Strengths' => 'Strengths',
	   'Challenges' => 'Challenges',
	   'Assessments' => 'Assessments',
	   'Additional' => 'Additional',
	   'Student' => 'Student',
	   'Record Updated' => 'Record Updated',


	   );

my $self = 'iepstuded.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"$lex{'Please Log In'}\">\n";
    print "</form></body></html>\n";
    exit;

}

my $userid = $session->param('userid');


# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Get homeroom and check access credentials.
my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'homeroom' and userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while ( my $homeroom = $sth->fetchrow ) {
    $homerooms{$homeroom} = 1;
}

# Get Access credentials
my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'access' and userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while ( my $ac = $sth->fetchrow ) {
    $access{$ac} = 1;
}


my $title = "$lex{Edit} $lex{Student} - IEP";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print "</head><body>\n";

print qq{[ <a href="$tchpage">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( $arr{page} ) {
    delete $arr{page};
    writeRecord();
}


my $sth = $dbh->prepare("select * from iep_student where id = ?");
$sth->execute( $arr{id} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  
my $ref = $sth->fetchrow_hashref;
my %st = %$ref;
my $studnum = $st{studnum};


# Check for access.
if ( not $access{IEP} and not $homerooms{$hr} ){

    # Check if any grades have subject attendance, 
    # and check those grades for course enrollments
    my $sth = $dbh->prepare("select count(e.id) from eval e, subject s 
      where e.studnum = ? and e.subjcode = s.subjsec and s.teacher = ?");
    $sth->execute( $arr{studnum}, $userid );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  
    my $count = $sth->fetchrow;
    if ( $count < 1 ) {
	print qq{<h3>No Access Allowed</h3>\n};
	print qq{</body></html>\n};
	exit;
    }
}



print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$st{id}\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border = \"0\">\n";

print "<tr><td align=\"right\">". $lex{'Last Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"30\" value=\"$st{lastname}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'First Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"30\" value=\"$st{firstname}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Birthdate}. "</td>\n<td>";
print "<input type=\"text\" name=\"birthdate\" size=\"15\" value=\"$st{birthdate}\">";
print " (yyyy-mm-dd)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Student Number'}. "</td><td>$st{studnum}</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Provincial Number'}. "</td>\n<td>";
print "<input type=\"text\" name=\"provnum\" size=\"12\" value=\"$st{provnum}\"></tr>\n";

#print "<tr><td align=\"right\">". $lex{'Designation Date'}. "</td>\n<td>";
#print "<input type=\"text\" name=\"desdate\" size=\"15\" value=\"$st{desdate}\">\n";
#print " (yyyy-mm-dd)</td></tr>\n";

#print "<tr><td align=\"right\">". $lex{'DDPF Level'}. "</td>\n<td>";
#print "<select name=\"ddpflvl\"><option>$st{ddpflvl}</option><option>Level 1</option>\n";
#print "<option>Level 2</option></td></tr>\n";

#print "<tr><td align=\"right\">". $lex{Designation}. "</td>\n<td>";
#print "<select name=\"designation\"><option>$st{designation}</option>\n";
#foreach my $desig ( @designate ) {
#    print "<option>$desig</option>\n";
#}
#print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Grade}. "</td>\n<td>";
print "<input type=\"text\" name=\"grade\" size=\"4\" value=\"$st{grade}\"></td></tr>\n";

#print "<tr><td align=\"right\">". $lex{School}. "</td>\n<td>";
#print "<select name=\"school\"><option>$st{school}</option>\n";
#foreach my $key ( keys %dbase ) {
#    print "<option>$dbase{$key} ($key)</option>\n";
#}
#print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Gender}. "</td>\n<td>";
print "<select name=\"sex\"><option>$st{sex}</option>\n";
print "<option>". $lex{M}. "</option><option>". $lex{F};
print "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Medical Conditions'}. "</td>\n<td>";
print "<textarea name=\"medical\" rows=\"6\" cols=\"100\">$st{medical}</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Medication}. "</td>\n<td>";
print "<textarea name=\"medication\" rows=\"6\" cols=\"100\">$st{medication}</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Equipment}. "</td>\n<td>";
print "<textarea name=\"equip\" rows=\"6\" cols=\"100\">$st{equip}</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Adaptations}. "</td>\n<td>";
print "<textarea name=\"adapt\" rows=\"6\" cols=\"100\">$st{adapt}</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'School/Home History'}. "</td>\n<td>";
print "<textarea name=\"history\" rows=\"6\" cols=\"100\">$st{history}</textarea></td></tr>\n";


print "<tr><td align=\"right\" valign=\"top\">". $lex{Strengths}. "</td>\n<td>";
print "<textarea name=\"strengths\" rows=\"6\" cols=\"100\">$st{strengths}</textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Challenges}. "</td>\n<td>";
print "<textarea name=\"challenges\" rows=\"6\" cols=\"100\">$st{challenges}</textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Assessments}. "</td>\n<td>";
print "<textarea name=\"assessments\" rows=\"6\" cols=\"100\">$st{assessments}</textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Additional}. "</td>\n<td>";
print "<textarea name=\"additional\" rows=\"6\" cols=\"100\">$st{additional}</textarea></td></tr>\n";


print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"";
print $lex{'Save Student Record'}. "\"></td></tr></table>\n";

print "</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id}; # remove the record id from values to be updated.
    delete $arr{id}; 

    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update iep_student set $key = ? where id = $id ");
	$sth->execute( $arr{$key} );
	if ( $DBI::errstr ) { print qq{$lex{Error}:$DBI::errstr}; die $DBI::errstr; }
    }


    print qq{<h3>$lex{'Record Updated'}</h3>\n};


    # print "[ <a href=\"$tchhome\">$lex{Main}</a> ]\n";

    print qq{<form action="iepstuddeled.pl" method="post">\n};
    print qq{<input type="submit" value=\"$lex{Edit} $lex{'More Students'}">\n};
    print qq{</form>\n};
    print qq{</body></html>\n};

    exit;

} # end of writeRecord
