#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

# This file is part of Open Admin for Schools.

my %lex = ('Team Builder' => 'Team Builder',
	   'Main' => 'Main',
	   'Please select the student team members' => 'Please select the student team members',
	   'Select Student' => 'Select Student',
	   'Add Members to the Student\'s Team' => 'Add Members to the Student\'s Team',
	   'Personnel' => 'Personnel',
	   'Name' => 'Name',
	   'Position' => 'Position',
	   'Userid' => 'Userid',
	   'Select' => 'Select',
	   'Signer' => 'Signer',
	   'Add More Team Members' => 'Add More Team Members',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'Your new team members are now stored' => 'Your new team members are now stored',
	   'Y' => 'Y',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Assessments' => 'Continue to Add Assessments',

	   );

my $self = 'teamadd_local.pl';

use DBI;
use CGI;
use CGI::Session;


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></body></html>\n";
    die;
}

my $userid = $session->param('userid');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;



# Read in all special students and put in array/hash
my $sth = $dbh->prepare("select lastname, firstname, studnum from iep_student
  order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my (%students,@students);
while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
    push @students, $studnum;
    $students{$studnum} = "$lastname, $firstname ($studnum)";
}
# Done storing students.


# Print Page Header
my $title = $lex{'Team Builder'};
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$tchpage\">$lex{Main}</a> ] $firstname $lastname\n";
print "<h1>$title</h1>\n";

if ( $arr{page} ) {
    delete $arr{page};
    writeRecord();
}


my $passedstudent;
if ( $arr{studnum} ) {
    my $sth = $dbh->prepare("select lastname, firstname from iep_student
      where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    $passedstudent = "$lastname, $firstname ($arr{studnum})";
}


print "<p>$lex{'Please select the student team members'}</p>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

print "<table cellpadding=\"6\" cellspacing=\"0\" border=\"1\">\n";
print qq{<tr><td class="bcn">$lex{'Select Student'}:\n};
print qq{<select name="student"><option value="$arr{studnum}">$passedstudent</option>\n};

foreach my $studnum ( @students ) {
    print qq{<option value="$studnum">$students{$studnum}</option>\n};
}
print "</select></td></tr></table>\n";

print "<p></p><input type=\"submit\" value=\"";
print $lex{'Add Members to the Student\'s Team'}. "\">\n";

=head
# Now pull in the personnel table.
my $sth = $dbh->prepare("select userid, lastname, firstname, jobtitle from personnel
 order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    

# Now print Personnel
print "<h2>". $lex{Personnel}. "</h2>\n";
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
print "</th><th>". $lex{Select}. "</th><th>". $lex{Signer}. "</th></tr>\n";

while ( my ($userid, $lastname, $firstname, $jobtitle) = $sth->fetchrow ) {
    print "<tr><td><b>$lastname</b>, $firstname</td><td>$jobtitle</td>\n";
    print "<td>$userid</td><td align=\"center\">\n";
    print "<input type=\"checkbox\" name=\"per:$userid\" value=\"1\"></td>\n";
    print "<td><input type=\"checkbox\" name=\"per:$userid:sign\" value=\"1\"></td></tr>\n";
}
print "</table>\n";
=cut

    
my $sth = $dbh->prepare("select s.sal, s.lastname, s.firstname, s.userid, sm.field_value 
  from staff as s, staff_multi as sm where s.userid = sm.userid and sm.field_name = 'position'
  order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


print "<h2>$schoolname</h2>\n";
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"2\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
print "</th><th>". $lex{Select}. "</th><th>". $lex{Signer}. "</th></tr>\n";

while ( my ($sal, $lastname, $firstname, $userid,$position) = $sth->fetchrow ) {
    print "<tr><td><b>$lastname</b>, $sal $firstname</td><td>$position</td>\n";
    print "<td>$userid</td><td align=\"center\"> ";
    print "<input type=\"checkbox\" name=\"$userid\" value=\"1\"></td>\n<td>";
    print "<input type=\"checkbox\" name=\"$userid:sign\" value=\"1\"></td></tr>\n";
}
print "</table>\n";

print "<p></p><input type=\"submit\" value=\"";
print $lex{'Add Members to the Student\'s Team'}. "\">\n";

print "</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    # foreach $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not $arr{student} ){
	print "<h1>No Student Entered. Please try again.</h1>\n";
	print "</body></html>\n";
	exit;
    }

    my $studnum = $arr{student};
    delete $arr{student};


    foreach $key ( keys %arr ) {

	if ( $arr{$key} ==1 ) { # We have a selection for team membership
	    my ($userid, $sign) = split(':',$key);
	    if ( $sign ){ next;} # skip over signing records
	    # print "U:$userid S:$sign<br>\n";

	    my ($signer, $email, $jobtitle, $phone, $val);
	    $sth1 = $dbh->prepare("select s.lastname, s.firstname, sm.field_value, s.email 
               from staff as s, staff_multi as sm where s.userid = sm.userid and 
               sm.field_name = 'position' and s.userid = ?");
	    $sth1->execute( $userid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $lastname, $firstname, $position, $email ) = $sth1->fetchrow;

	    $user = "$firstname $lastname ($key)";
	    $jobtitle = $position;
	    $phone = $g_phone{$group};
	    $val = $key.":sign";
	    if ( $arr{$val} ){ $signer = $lex{Y}; }
	    # print "K: $key V:$val  S:$signer\n";
	    
	    my $sth = $dbh->prepare("insert into iep_team (studnum, userid, jobtitle, phone, email, sign )
             values ( ?, ?, ?, ?, ?, ? )");
	    $sth->execute( $studnum, $user, $jobtitle, $phone, $email, $signer );;
	    if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }

	} # End of If for course Entry

    } # End of Entry Loop


    if ( not $DBI::errstr ) {
	print qq{<h3>$lex{'Your new team members are now stored'}</h3>\n};
	
    } else {
	print qq{<h3>$lex{'There was an error storing your data'} \n};
	print qq{$lex{Contact} $adminname <a href=\"mailto:$adminemail\">$adminname</a>\n};
	print qq{$lex{'Please record the following error'}: $DBI::errstr\n};
    }

    print qq{<p>[ <a href="$tchpage">$lex{Main}</a> |\n};
    print qq{<a href=\"$self?studnum=$studnum\">$lex{'Add More Team Members'}</a> |\n};
    print qq{</p></body></html>\n};

    exit;

} # end of writeRecord
